local p = ...
-- a table to store the vertices
local verts= {}
-- Get our song
local steptype = GAMESTATE:GetCurrentSteps(p):GetStepsType()
local IsEndless = GAMESTATE:GetPlayMode() == "PlayMode_Endless"
local vStats = STATSMAN:GetCurStageStats():GetPlayerStageStats( p );
local SongOrCourse = GAMESTATE:IsCourseMode() and GAMESTATE:GetCurrentCourse() or GAMESTATE:GetCurrentSong()
local FirstSecond = function()
	if GAMESTATE:IsCourseMode() then
		return 0
	end
	return SongOrCourse:GetFirstSecond()
end
local TotalSeconds = function()
	if GAMESTATE:IsCourseMode() then
		local trail = GAMESTATE:GetCurrentTrail(GAMESTATE:GetMasterPlayerNumber());
		if not IsEndless then
			if trail then
				return TrailUtil.GetTotalSeconds(trail);
			end;
			return 0;
		end
		return vStats:GetAliveSeconds()
	end
	return SongOrCourse:GetLastSecond()
end
local OffsetTable = getenv("OffsetTable")
local Offset, CurrentSecond, NoteType, x, y
local OffLimit = 0.25
local BodyWidth, BodyHeight = 333,78

-- Grab the table.
for x in ivalues(OffsetTable[p]) do
	-- Set contents to recgonizable locals.
	CurrentSecond = x[1]
	Offset = x[2]
	NoteType = x[3]

	if Offset ~= "Miss" then
		CurrentSecond = CurrentSecond - Offset
	else
		CurrentSecond = CurrentSecond - OffLimit
	end

	-- Let's scale the graph
	x = scale(CurrentSecond, FirstSecond(), TotalSeconds(), -BodyWidth/2, BodyWidth/2)

	-- Check if the current item is not Miss
	if Offset ~= "Miss" then
		local val = "JudgmentLine_"..ToEnumShortString( NoteType )
		-- Set the y position to about the position where the limit would be
		y = scale(Offset, OffLimit, -OffLimit, 0, BodyHeight)
		local ColorType = JudgmentLineToColor( val )

		-- Now create a Square, with the judgment color
		table.insert( verts, {{x, y, 0}, ColorType } )
		table.insert( verts, {{x+1.5, y, 0}, ColorType } )
		table.insert( verts, {{x+1.5, y+1.5, 0}, ColorType } )
		table.insert( verts, {{x, y+1.5, 0}, ColorType } )
	else
		-- If it was a miss, create a tall rectangle to indicate it.
		table.insert( verts, {{x, 0, 0}, color("#ff000077")} )
		table.insert( verts, {{x+2, 0, 0}, color("#ff000077")} )
		table.insert( verts, {{x+2, BodyHeight, 0}, color("#ff000077")} )
		table.insert( verts, {{x, BodyHeight, 0}, color("#ff000077")} )
	end
end;

-- Finally, put everything to a AMV.
-- It turns out this is way better than doing a Quad loop as it reduces the
-- ammount of Draw calls drastically.
local oldzoom = 0
local amv = Def.ActorMultiVertex{
	OnCommand=function(self)
		self:SetDrawState{Mode="DrawMode_Quads"}:SetVertices(verts)
	end,
	ScatterZoomMessageCommand=function(s,param)
		if param.Player == p then
			s:stoptweening():decelerate(0.2)
			
			-- If the player requests a zoom, we need to redo the entire thing again.
			--
			verts = {}
			for x in ivalues(OffsetTable[p]) do
				-- Set contents to recgonizable locals.
				CurrentSecond = x[1]
				Offset = x[2]
				NoteType = x[3]

				if Offset ~= "Miss" then
					CurrentSecond = CurrentSecond - Offset
				else
					CurrentSecond = CurrentSecond - OffLimit
				end

				-- Let's scale the graph
				x = scale(CurrentSecond, FirstSecond(), TotalSeconds(), -BodyWidth*(param.Zoom), BodyWidth*(param.Zoom))

				-- Check if the current item is not Miss
				local zoomsizepam = scale( param.Zoom, 1, 10, 1.5, 2.5 )
				if Offset ~= "Miss" then
					local val = "JudgmentLine_"..ToEnumShortString( NoteType )
					-- Set the y position to about the position where the limit would be
					y = scale(Offset, OffLimit, -OffLimit, 0, BodyHeight)
					local ColorType = JudgmentLineToColor( val )

					-- Now create a Square, with the judgment color
					table.insert( verts, {{x, y, 0}, ColorType } )
					table.insert( verts, {{x+1.5*zoomsizepam, y, 0}, ColorType } )
					table.insert( verts, {{x+1.5*zoomsizepam, y+1.5*zoomsizepam, 0}, ColorType } )
					table.insert( verts, {{x, y+1.5*zoomsizepam, 0}, ColorType } )
				else
					-- If it was a miss, create a tall rectangle to indicate it.
					table.insert( verts, {{x, 0, 0}, color("#ff000077")} )
					table.insert( verts, {{x+2*zoomsizepam, 0, 0}, color("#ff000077")} )
					table.insert( verts, {{x+2*zoomsizepam, BodyHeight, 0}, color("#ff000077")} )
					table.insert( verts, {{x, BodyHeight, 0}, color("#ff000077")} )
				end
			end


			--[[
			for i=1,#verts,4 do
				local zoomsizepam = scale( param.Zoom, 1, 10, 1.5, 2.5 )
				local xpos = scale(verts[i][1][1], -BodyWidth*(oldzoom), BodyWidth*(oldzoom), -BodyWidth*(param.Zoom), BodyWidth*(param.Zoom))
				verts[i][1][1] = verts[i][1][1]
				verts[i+1][1][1] = verts[i+1][1][1]+1.5*zoomsizepam
				verts[i+2][1][1] = verts[i+2][1][1]+1.5*zoomsizepam
				verts[i+3][1][1] = verts[i+3][1][1]
			end
			]]
			
			s:SetNumVertices( #verts ):SetVertices( verts )
			oldzoom = param.Zoom
			s:x( param.Zoom > 1 and -scale(param.Xpos, 1, param.MaxSegment, 0, BodyWidth) or 0 )
		end
	end,
	ScatterMoveMessageCommand=function(s,param)
		if param.Player == p then
			s:stoptweening():decelerate(0.2)
			s:x( param.Zoom > 1 and -scale(param.Xpos, 1, param.MaxSegment, 0, BodyWidth) or 0 )
		end
	end,
}

return amv;
