local ColorTable = LoadModule("Theme.Colors.lua")( LoadModule("Config.Load.lua")("SoundwavesSubTheme","Save/OutFoxPrefs.ini") )
local currentSubTheme = LoadModule("Config.Load.lua")("SoundwavesSubTheme","Save/OutFoxPrefs.ini")
local AnimatedMenu = LoadModule("Config.Load.lua")("FancyUIBG","Save/OutFoxPrefs.ini")

local LoadMenuBG = Def.ActorFrame{}

-- Conditionals
if AnimatedMenu then 
	if currentSubTheme ~= "4" then
		LoadMenuBG[#LoadMenuBG+1] = Def.ActorFrame {
			Def.Sprite {
				Texture = THEME:GetPathG("_bg", "big grid"),
				InitCommand=function(self)
					self:diffuse( ColorTable["titleBGPattern"] ):diffusealpha(0.05):blend('add'):zoomto(SCREEN_WIDTH*1.4,SCREEN_HEIGHT*1.4):customtexturerect(0,0,SCREEN_WIDTH*4/512,SCREEN_HEIGHT*4/512):xy(SCREEN_CENTER_X,SCREEN_CENTER_Y)
				end,
				OnCommand=function(self)
					self:texcoordvelocity(0,0.15):rotationx(-20):fadeleft(0.4):faderight(0.4)
				end
			},
				
			Def.Sprite {
				Texture = THEME:GetPathG("_bg", "big grid");
				InitCommand=function(self)
					self:diffuse( ColorTable["titleBGPattern"] ):diffusealpha(0.05):blend('add'):zoomto(SCREEN_WIDTH*1.4,SCREEN_HEIGHT*1.4):customtexturerect(0,0,SCREEN_WIDTH*4/512,SCREEN_HEIGHT*4/512):xy(SCREEN_CENTER_X,SCREEN_CENTER_Y)
				end,
				OnCommand=function(self)
					self:texcoordvelocity(0,0.15):rotationx(-20):fadeleft(0.4):faderight(0.4)
				end
			}
		}
	end
else
	if currentSubTheme ~= "4" then
		LoadMenuBG[#LoadMenuBG+1] = Def.Sprite {
			Texture = THEME:GetPathG("_bg", "big grid"),
			InitCommand=function(self)
				self:diffusealpha(0.04):blend('add'):zoomto(SCREEN_WIDTH+100,SCREEN_HEIGHT+190):customtexturerect(0,0,SCREEN_WIDTH*4/512,SCREEN_HEIGHT*4/512):xy(SCREEN_CENTER_X,SCREEN_CENTER_Y)
			end
		}
	end
end

if AnimatedMenu and currentSubTheme == "4" then 
	LoadMenuBG[#LoadMenuBG+1] = Def.Sprite {
		Texture = THEME:GetPathG("_retro", "checkerboard"),
		InitCommand=function(self)
			self:diffuse(color("#FFD400")):zoomto(SCREEN_WIDTH*1.4,SCREEN_HEIGHT+190*1.8):visible(false)
			:customtexturerect(0,0,SCREEN_WIDTH*4/512,SCREEN_HEIGHT*4/512):xy(SCREEN_CENTER_X,SCREEN_CENTER_Y)
		end;
		OnCommand=function(self)
			if currentSubTheme == "4" then
				self:visible(true)
			end
			self:texcoordvelocity(0,0.30):rotationx(-60):fadetop(0.5)
		end
	}
end

return Def.ActorFrame {
	InitCommand=function(self) self:fov(80) end,
	OnCommand=function(self)
		GAMESTATE:UpdateDiscordGameMode(GAMESTATE:GetCurrentGame():GetName())
		GAMESTATE:UpdateDiscordScreenInfo("Title Menus","",1)
	end,
	Def.Quad {
		InitCommand=function(self) self:xy(SCREEN_CENTER_X,SCREEN_CENTER_Y):zoomto(SCREEN_WIDTH,SCREEN_HEIGHT) end,
		OnCommand=function(self) self:diffuse( ColorTable["titleBGA"] ):diffusebottomedge( ColorTable["titleBGB"] ) end
	},
	LoadMenuBG
}
